package gr.uoi.binarycalculator;

public class BinaryNumber {
    private String value="";
    public BinaryNumber()
    {
        value="";
    }
    int bin2dec()
    {
        int total=0;
        int i;
        for(i=0;i<value.length();i++)
        {
            int bit=value.charAt(i)=='0'?0:1;
            total=2*total+bit;
        }
        return total;
    }
    void dec2bin(int x)
    {
        value="";
        while(x!=0)
        {
            int bit=x%2;
            value=bit+value;
            x=x/2;
        }
    }
    void addDigit(int x)
    {
        if(x==0 || x==1)
            value=value+x;
    }

    void addNumber(BinaryNumber other)
    {
        int n1=bin2dec();
        int n2=other.bin2dec();
        int n3=n1+n2;
        this.dec2bin(n3);
    }

    void subNumber(BinaryNumber other)
    {
        int n1=bin2dec();
        int n2=other.bin2dec();
        int n3=n1-n2;
        this.dec2bin(n3);
    }

    void removeLastDigit()
    {
        if(value.length()>0)
        {
            String x=value.substring(0, value.length()-1);

            value=x;
        }
    }

    public String toString()
    {
        return value;
    }
}